export declare abstract class Common {
    ios: any;
    android: any;
    config: any;
    constructor(databaseName: string);
    abstract createDocument(data: Object, documentId?: string): any;
    abstract getDocument(documentId: string): any;
    abstract updateDocument(documentId: string, data: any): any;
    abstract deleteDocument(documentId: string): any;
    abstract destroyDatabase(): any;
    abstract query(query: Query): any[];
    abstract createPullReplication(remoteUrl: string): any;
    abstract createPushReplication(remoteUrl: string): any;
    abstract addDatabaseChangeListener(callback: any): any;
}
export declare abstract class ReplicatorBase {
    replicator: any;
    constructor(replicator: any);
    abstract start(): any;
    abstract stop(): any;
    abstract isRunning(): any;
    abstract setContinuous(isContinuous: boolean): any;
}
export declare enum QueryMeta {
    ID = "COUCHBASE_ID",
}
export declare type QueryComparisonOperator = 'modulo' | 'is' | 'between' | 'isNot' | 'collate' | 'in' | 'add' | 'isNullOrMissing' | 'greaterThan' | 'divide' | 'notEqualTo' | 'greaterThanOrEqualTo' | 'like' | 'subtract' | 'lessThanOrEqualTo' | 'lessThan' | 'notNullOrMissing' | 'regex' | 'equalTo' | 'multiply';
export declare enum QueryLogicalOperator {
    AND = "and",
    OR = "or",
}
export declare enum QueryArrayOperator {
    CONTAINS = "contains",
}
export interface Query {
    select: any[];
    where?: any[];
    groupBy?: any;
    order?: QueryOrderItem[];
    limit?: any;
    from?: string;
}
export interface QueryWhereItem {
    property: string;
    comparison: QueryComparisonOperator;
    value: any;
}
export interface QueryOrderItem {
    property: string;
    direction: 'asc' | 'desc';
}
